﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RadPivotGrid_CustomDateTimeOffset
{
    public class GroupObj : IComparable, IComparable<GroupObj>
    {
        public DateTimeOffset StartTime { get; private set; }

        public GroupObj(DateTimeOffset dt)
        {
            DateTimeOffset startOfGroup = new DateTimeOffset(1, 1, 1, dt.Hour, dt.Minute, 0, TimeSpan.Zero);
            this.StartTime = startOfGroup;
        }

        public override string ToString()
        {
            return this.StartTime.ToString("HH : 00");
        }

        public override int GetHashCode()
        {
            return this.StartTime.GetHashCode();
        }

        public override bool Equals(object obj)
        {
            GroupObj go = obj as GroupObj;

            if (go == null)
            {
                return false;
            }
            else
            {
                return this.StartTime == go.StartTime;
            }
        }

        public int CompareTo(object obj)
        {
            return this.CompareTo(obj as GroupObj);
        }

        public int CompareTo(GroupObj other)
        {
            return other == null ? -1 : this.StartTime.CompareTo(other.StartTime);
        }
    }
}
